{------------------------------------------------------------------------------}
{        This code is copyright (C) 2008-2025 by Michael in der Wiesche        }
{------------------------------------------------------------------------------}
{$J+,Z4}
unit DlgMsgBoxes;

interface

uses
  Windows, ShellApi, Messages, MDResources;

procedure ShowHelpDialog(ParentHandle: THandle; const Text, Caption: String);
procedure ShowInfoDialog(ParentHandle: THandle; const Text, Caption: String);
procedure ShowWarnDialog(ParentHandle: THandle; const Text, Caption: String);
procedure ShowErrorDialog(ParentHandle: THandle; const Text, Caption: String);

implementation

const
  MB_STYLE = MB_OK or MB_SETFOREGROUND;

procedure ShowHelpDialog(ParentHandle: THandle; const Text, Caption: String);
var
  mbp: TMsgBoxParamsW;
begin
  with mbp do begin
    cbSize := SizeOf(TMsgBoxParams);
    hwndOwner := ParentHandle;
    hInstance := GetModuleHandle(Shell32);
    lpszText := PChar(Text);
    lpszCaption := PChar(Caption);
    dwStyle := MB_STYLE or MB_USERICON;
    lpszIcon := MakeIntResource(24);
    dwContextHelpId := 0;
    lpfnMsgBoxCallback := NIL;
    dwLanguageId := 0;
  end;
  MessageBoxIndirect(mbp);
  PostMessage(ParentHandle, WM_CANCELMODE, 0, 0);
end;

procedure ShowInfoDialog(ParentHandle: THandle; const Text, Caption: String);
begin
  MessageBox(ParentHandle, PChar(Text), PChar(Caption), MB_STYLE or MB_ICONINFORMATION);
end;

procedure ShowWarnDialog(ParentHandle: THandle; const Text, Caption: String);
begin
  MessageBox(ParentHandle, PChar(Text), PChar(Caption), MB_STYLE or MB_ICONWARNING);
end;

procedure ShowErrorDialog(ParentHandle: THandle; const Text, Caption: String);
begin
  MessageBox(ParentHandle, PChar(Text), PChar(Caption), MB_STYLE or MB_ICONERROR);
end;

end.

