{------------------------------------------------------------------------------}
{        This code is copyright (C) 2008-2025 by Michael in der Wiesche        }
{------------------------------------------------------------------------------}
{$J+,Z4}
unit DlgProgress;

{$R 'DlgProgress.res' 'DlgProgress.rc'}

interface

uses
  Windows, Messages, CommCtrl, SysUtils, FileTools, StrTools, WindowTools, MDResources;

procedure ShowProgressDialog(ParentHandle: THandle; LangOffset: Integer);
procedure HideProgressDialog;

implementation

type
  PDialogParams = ^TDialogParams;
  TDialogParams = Record
    DialogHandle: THandle;
    ParentHandle: THandle;
    LangOffset: Integer;
  end;

const
  DlgParams: TDialogParams = (DialogHandle: 0; ParentHandle: 0; LangOffset: 0);

function ProgressDialogProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
  Result := 0;
  case uMsg of
    WM_SHOWWINDOW: if wParam <> 0 then CenterDialog(hWnd, GetWindowLongPtr(hWnd, GWLP_HWNDPARENT));
    WM_INITDIALOG: with PDialogParams(lParam)^ do begin
      DialogHandle := hWnd;
      SetWindowText(hWnd, PChar(Unquote(GetVersionInformation, LB, RB)));
      SendMessage(GetDlgItem(hWnd, PB_WRITE_DUMP), PBM_SETMARQUEE, 1, 30);
      if LangOffset > 0 then SetControlText(hWnd, LangOffset, LBL_WRITE_DUMP, E);
      EnableMenuItem(GetSystemMenu(hWnd, FALSE), SC_CLOSE, MF_BYCOMMAND or MF_GRAYED);
    end;
  end;
end;

procedure ShowProgressDialog(ParentHandle: THandle; LangOffset: Integer);
begin
  DlgParams.LangOffset := LangOffset;
  if ParentHandle <> GetCurrentProcess then
    DlgParams.ParentHandle := 0
  else DlgParams.ParentHandle := ParentHandle;
  CreateDialogParam(HInstance, MakeIntResource(DLG_PROGRESS), DlgParams.ParentHandle, @ProgressDialogProc, LPARAM(@DlgParams));
end;

procedure HideProgressDialog;
begin
  DestroyWindow(DlgParams.DialogHandle);
  DlgParams.DialogHandle := 0;
  DlgParams.ParentHandle := 0;
  DlgParams.LangOffset := 0;
end;

end.

