{------------------------------------------------------------------------------}
{        This code is copyright (C) 2008-2025 by Michael in der Wiesche        }
{------------------------------------------------------------------------------}
{$J+,Z4}
unit DlgSaveDump;

interface

uses
  Windows, CommDlg, SysUtils, StrTools, MDResources;

function ShowSaveFileDialog(ParentHandle: THandle; const Title, FileName: String): String;

implementation

function ShowSaveFileDialog(ParentHandle: THandle; const Title, FileName: String): String;
const
  SAVE_FILE_FLAGS = OFN_ENABLEHOOK or OFN_EXPLORER or OFN_NOCHANGEDIR or OFN_OVERWRITEPROMPT or OFN_PATHMUSTEXIST;
  DUMPFILE_FILTER = 'Dumps' + NUL + '*.dmp' + NUL;
  ALLFILE_FILTER = 'All' + NUL + '*.*' + NUL;
  DEF_FILE_EXT = 'dmp';
var
  ofne: TOpenFileName;
  iLen: Integer;
begin
  try
    FillChar(ofne, SizeOf(TOpenFileName), 0);
    with ofne do begin
      lStructSize := SizeOf(TOpenFileName);
      if Lo(GetVersion) < 5 then dec(lStructSize, 12);
      hWndOwner := ParentHandle;
      lpstrFilter := DUMPFILE_FILTER + ALLFILE_FILTER + NUL;
      iLen := Length(FileName);
      if iLen >= MAX_PATH then
	SetString(Result, NIL, iLen)
      else SetString(Result, NIL, MAX_PATH);
      if FileName <> E then StrTools.StrLCopy(PChar(Result), PChar(FileName), Length(FileName));
      lpstrFile := PChar(Result);
      nMaxFile := succ(MAX_PATH);
      lpstrTitle := PChar(Title);
      Flags := SAVE_FILE_FLAGS;
      lpstrDefExt := DEF_FILE_EXT;
    end;
    if GetSaveFileName(ofne) then
      Result := ofne.lpstrFile
    else Result := E;
  except
    Result := E;
  end;
end;

end.

