{------------------------------------------------------------------------------}
{        This code is copyright (C) 2008-2025 by Michael in der Wiesche        }
{------------------------------------------------------------------------------}
{$J+,Z4}
unit DlgVersionInfo;

interface

uses
  Windows, Messages, SysUtils, StrTools, FileTools, WindowTools, MDResources;

function ShowVersionDialog(ParentHandle: THandle; LangOffset: Integer): Integer;

implementation

function VersionDialogProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

  function ProductVersion: String;
  var
    fvi: TFileVersionInfo;
  begin
    with fvi do begin
      QueryFile := GetModuleName(HInstance);
      QueryParameters := [fviProductVersion];
      if FileVersionInfo(fvi) then begin
	Result := ProductVersion;
	Exit;
      end;
    end;
    Result := E;
  end;

  procedure UpdateCheck(Dialog: THandle; LangOffset: Integer);
  var
    sResult: String;
  begin
    sResult := UpdateAvailable(Dialog, LangOffset);
    SetControlText(Dialog, LangOffset, LBL_VER_STATUS, sResult);
    EnableWindow(GetDlgItem(Dialog, BTN_VER_DOWNLOAD), sResult = Str(LangOffset + STR_UPDATE_STATUS));
  end;

begin
  Result := 0;
  case uMsg of
    WM_SHOWWINDOW: if wParam <> 0 then CenterDialog(hWnd, GetWindowLongPtr(hWnd, GWLP_HWNDPARENT));
    WM_INITDIALOG: begin
      if lParam > 0 then begin
	SetControlText(hWnd, lParam, LBL_VER_INFO, E);
	SetControlText(hWnd, lParam, LBL_VER_STATUS, E);
	SetControlText(hWnd, lParam, BTN_VER_DOWNLOAD, E);
	SetControlText(hWnd, lParam, BTN_VER_CLOSE_DIALOG, E);
      end;
      if SetDlgItemText(hWnd, LBL_VER_INFO, PChar(DialogString(hWnd, LBL_VER_INFO) + ProductVersion)) then UpdateCheck(hWnd, lParam);
    end;
    WM_COMMAND: if HiWord(wParam) = BN_CLICKED then begin
      case LoWord(wParam) of
	ID_CANCEL: Result := Ord(EndDialog(hWnd, ID_CANCEL));
	BTN_VER_DOWNLOAD: Result := Ord(EndDialog(hWnd, BTN_VER_DOWNLOAD));
	BTN_VER_CLOSE_DIALOG: Result := Ord(EndDialog(hWnd, BTN_VER_CLOSE_DIALOG));
      end;
    end;
    WM_SYSCOMMAND: begin
      case wParam of
	SC_CLOSE: Result := Ord(EndDialog(hWnd, ID_CANCEL));
      end;
    end;
  end;
end;

function ShowVersionDialog(ParentHandle: THandle; LangOffset: Integer): Integer;
begin
  try
    Result := DialogBoxParam(HInstance, MakeIntResource(DLG_VERSION_INFO), ParentHandle, @VersionDialogProc, LangOffset);
  except
    Result := 0;
  end;
end;

end.

